## rustc 1.67.1+dfsg0ubuntu1

=== src/test/run-make/native-link-modifier-verbatim-linker/Makefile ===
# ignore-cross-compile
# ignore-macos

include ../../run-make-fulldeps/tools.mk

all:
	# Verbatim allows specify precise name.
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_some_strange_name.ext
	$(RUSTC) main.rs -l static:+verbatim=local_some_strange_name.ext

	# With verbatim any other name cannot be used (local).
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/liblocal_native_dep.a
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_native_dep.a
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_native_dep.lib
	$(RUSTC) main.rs -l static:+verbatim=local_native_dep 2>&1 | $(CGREP) "local_native_dep"

=== src/test/run-make/repr128-dwarf/Makefile ===
# ignore-windows
# This test should be replaced with one in src/test/debuginfo once GDB or LLDB support 128-bit
# enums.

include ../../run-make-fulldeps/tools.mk

all:
	$(RUSTC) -Cdebuginfo=2 lib.rs -o $(TMPDIR)/repr128.rlib
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n U128A $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n U128B $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n U128C $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> 00 00 00 00 00 00 00 00 01 00 00 00 00 00 00 00 )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n U128D $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n I128A $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n I128B $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n I128C $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 80 )"
	"$(LLVM_BIN_DIR)"/llvm-dwarfdump -n I128D $(TMPDIR)/repr128.rlib | $(CGREP) "DW_AT_const_value	(<0x10> ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff 7f )"

=== src/test/run-make/test-benches/Makefile ===
include ../../run-make-fulldeps/tools.mk

# ignore-cross-compile

all:
	# Smoke-test that `#[bench]` isn't entirely broken.
	$(RUSTC) --test smokebench.rs -O
	$(call RUN,smokebench --bench)
	$(call RUN,smokebench --bench noiter)
	$(call RUN,smokebench --bench yesiter)
	$(call RUN,smokebench)

=== debian/changelog ===
rustc (1.67.1+dfsg0ubuntu1-0ubuntu2) lunar; urgency=medium

  * Fix an issue where rustc can not find the standard library
    - d/p/ubuntu-fix-sysroot-detection.patch: Fix sysroot detection
      logic so that rustc will find the correct library paths to
      search in.

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 22 Feb 2023 21:38:58 -0700

rustc (1.67.1+dfsg0ubuntu1-0ubuntu1) lunar; urgency=medium

  * New upstream release 1.67.1 (LP: #2007642)
    - d/p/d-bootstrap-use-local-css.patch: Remove unnecessary hunks
    - d/p/ubuntu-disable-sse2-tests-on-i386.patch: Disable SSE2 tests
      on i386 builds
    - d/copyright: Update copyright information for new dependencies
      and also remove copyright data for deleted dependencies
    - d/patches: Refresh patches
    - d/control: Update vendored deps field
    - d/control: Refresh vendored dependencies list
    - d/source/lintian-overrides: add new test files to the list

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 14 Feb 2023 14:34:02 -0700

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.66.0+dfsg) <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.67.1++)    <!pkg.rustc.dlstage0>,
 llvm-15-dev:native,
 llvm-15-tools:native,
 libclang-rt-15-dev (>= 1:15.0.7),
 libclang-common-15-dev (>= 1:15.0.7),
 libllvm15 (>= 1:15.0.7),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
 fonts-nanum <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-15:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust
XS-Vendored-Sources-Rust: addr2line@0.17.0, adler@1.0.2, ahash@0.7.6, aho-corasick@0.7.18, always-assert@0.1.2, ammonia@3.2.0, annotate-snippets@0.9.1, ansi_term@0.12.1, anyhow@1.0.65, ar_archive_writer@0.1.1, array_tool@1.0.3, arrayvec@0.7.2, askama@0.11.0, askama_derive@0.11.0, askama_escape@0.10.2, askama_shared@0.12.0, atty@0.2.14, autocfg@1.1.0, backtrace@0.3.66, bitflags@1.3.2, block-buffer@0.10.2, bstr@0.2.17, bytecount@0.6.2, bytes@1.0.1, camino@1.1.1, cargo-platform@0.1.2, cargo_metadata@0.14.0, cargo_metadata@0.15.0, cc@1.0.76, cfg-if@0.1.10, cfg-if@1.0.0, chalk-derive@0.87.0, chalk-engine@0.87.0, chalk-ir@0.87.0, chalk-solve@0.87.0, chrono@0.4.19, clap@3.2.20, clap_complete@3.1.1, clap_derive@3.2.18, clap_lex@0.2.2, cmake@0.1.48, colored@2.0.0, compiler_builtins@0.1.84, compiletest_rs@0.9.0, convert_case@0.4.0, core-foundation-sys@0.8.3, countme@3.0.1, cov-mark@2.0.0-pre.1, cpufeatures@0.2.5, crc32fast@1.3.2, crossbeam-channel@0.5.6, crossbeam-deque@0.8.2, crossbeam-epoch@0.9.13, crossbeam-utils@0.8.14, crypto-common@0.1.6, cstr@0.2.8, ctor@0.1.22, dashmap@5.4.0, datafrog@2.0.1, derive-new@0.5.8, derive_more@0.99.17, diff@0.1.13, digest@0.10.6, dirs-next@2.0.0, dirs-sys-next@0.1.2, dirs-sys@0.3.6, dirs@4.0.0, displaydoc@0.2.3, dissimilar@1.0.4, dlmalloc@0.2.3, drop_bomb@0.1.5, either@1.8.0, elasticlunr-rs@3.0.0, ena@0.14.0, env_logger@0.7.1, env_logger@0.9.0, errno-dragonfly@0.1.2, errno@0.2.8, expect-test@1.4.0, fallible-iterator@0.2.0, fastrand@1.8.0, fd-lock@3.0.8, filetime@0.2.18, fixedbitset@0.2.0, flate2@1.0.24, fluent-bundle@0.15.2, fluent-langneg@0.13.0, fluent-syntax@0.11.0, fnv@1.0.7, form_urlencoded@1.1.0, fortanix-sgx-abi@0.5.0, fs-err@2.8.1, futf@0.1.5, futures-channel@0.3.19, futures-core@0.3.19, futures-executor@0.3.19, futures-io@0.3.19, futures-macro@0.3.19, futures-sink@0.3.19, futures-task@0.3.19, futures-util@0.3.19, futures@0.3.19, generic-array@0.14.5, getopts@0.2.21, getrandom@0.1.16, getrandom@0.2.7, gimli@0.26.2, glob@0.3.0, globset@0.4.9, gsgdt@0.1.2, handlebars@4.3.3, hashbrown@0.12.3, heck@0.4.0, hermit-abi@0.1.19, hermit-abi@0.2.6, hex@0.4.3, home@0.5.4, html5ever@0.26.0, humantime@1.3.0, humantime@2.0.1, icu_list@1.0.0, icu_locid@1.0.0, icu_provider@1.0.1, icu_provider_adapters@1.0.0, icu_provider_macros@1.0.0, idna@0.3.0, if_chain@1.0.0, ignore@0.4.18, indexmap@1.9.1, indoc@1.0.6, instant@0.1.12, intl-memoizer@0.5.1, intl_pluralrules@7.0.2, io-lifetimes@1.0.2, itertools@0.10.5, itoa@1.0.4, jobserver@0.1.24, jsonpath_lib@0.2.6, lazy_static@1.4.0, lazycell@1.3.0, libc@0.2.138, libloading@0.7.3, libm@0.1.4, linux-raw-sys@0.1.3, litemap@0.6.0, lock_api@0.4.9, log@0.4.17, lsp-types@0.93.2, lzma-sys@0.1.17, mac@0.1.1, maplit@1.0.2, markup5ever@0.11.0, matchers@0.1.0, md-5@0.10.0, mdbook@0.4.21, measureme@10.1.0, memchr@2.5.0, memmap2@0.2.1, memmap2@0.5.7, memoffset@0.6.5, memoffset@0.7.1, minifier@0.2.2, minimal-lexical@0.2.1, miniz_oxide@0.5.4, miow@0.3.7, miow@0.5.0, new_debug_unreachable@1.0.4, nom@7.1.0, ntapi@0.4.0, num-integer@0.1.43, num-traits@0.2.12, num_cpus@1.13.1, object@0.29.0, odht@0.3.1, once_cell@1.16.0, opener@0.5.0, os_str_bytes@6.0.0, output_vt100@0.1.3, packed_simd_2@0.3.4, parking_lot@0.11.2, parking_lot@0.12.1, parking_lot_core@0.8.5, parking_lot_core@0.9.4, pathdiff@0.2.1, percent-encoding@2.2.0, perf-event-open-sys@1.0.1, perf-event@0.4.7, pest@2.3.0, pest_derive@2.3.0, pest_generator@2.3.0, pest_meta@2.3.0, petgraph@0.5.1, phf@0.10.1, phf_codegen@0.10.0, phf_generator@0.10.0, phf_shared@0.10.0, pin-project-lite@0.2.9, pin-utils@0.1.0, pkg-config@0.3.25, polonius-engine@0.13.0, ppv-lite86@0.2.8, precomputed-hash@0.1.1, pretty_assertions@1.3.0, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro-hack@0.5.19, proc-macro2@1.0.47, psm@0.1.21, pulldown-cmark@0.9.2, punycode@0.4.1, quick-error@1.2.3, quine-mc_cluskey@0.2.4, quote@1.0.21, rand@0.7.3, rand@0.8.5, rand_chacha@0.2.2, rand_chacha@0.3.0, rand_core@0.5.1, rand_core@0.6.2, rand_hc@0.2.0, rand_xorshift@0.2.0, rand_xoshiro@0.6.0, rayon-core@1.10.1, rayon@1.6.0, redox_syscall@0.2.16, redox_users@0.4.0, regex-automata@0.1.10, regex-automata@0.2.0, regex-syntax@0.6.27, regex@1.6.0, remove_dir_all@0.5.3, rls-data@0.19.1, rls-span@0.5.3, rowan@0.15.10, rustc-ap-rustc_lexer@725.0.0, rustc-demangle@0.1.21, rustc-hash@1.1.0, rustc-rayon-core@0.4.1, rustc-rayon@0.4.0, rustc-semver@1.1.0, rustc_tools_util@0.2.1, rustc_version@0.4.0, rustfix@0.6.1, rustix@0.36.3, rustversion@1.0.5, ryu@1.0.11, same-file@1.0.6, scoped-tls@1.0.0, scopeguard@1.1.0, self_cell@0.10.2, semver@1.0.14, serde@1.0.147, serde_derive@1.0.147, serde_json@1.0.86, serde_repr@0.1.9, sha-1@0.10.0, sha2@0.10.2, sharded-slab@0.1.4, shell-escape@0.1.5, shlex@1.0.0, siphasher@0.3.3, slab@0.4.2, smallvec@1.10.0, smol_str@0.1.23, snap@1.0.5, spdx-expression@0.5.2, spdx-rs@0.5.1, stable_deref_trait@1.2.0, stacker@0.1.15, string_cache@0.8.3, string_cache_codegen@0.5.2, strsim@0.10.0, strum@0.24.1, strum_macros@0.24.3, syn@1.0.102, synstructure@0.12.6, sysinfo@0.26.7, tar@0.4.38, tempfile@3.3.0, tendril@0.4.3, term@0.7.0, termcolor@1.1.2, termize@0.1.1, tester@0.9.0, text-size@1.1.0, textwrap@0.15.0, thin-vec@0.2.9, thiserror-impl@1.0.37, thiserror@1.0.37, thorin-dwp@0.3.0, thread_local@1.1.4, time@0.1.43, tinystr@0.7.0, tinyvec@1.6.0, tinyvec_macros@0.1.0, tokio@1.8.4, toml@0.5.9, topological-sort@0.1.0, tracing-attributes@0.1.23, tracing-core@0.1.30, tracing-log@0.1.3, tracing-subscriber@0.3.3, tracing-tree@0.2.1, tracing@0.1.37, type-map@0.4.0, typenum@1.16.0, ucd-parse@0.1.8, ucd-trie@0.1.3, ungrammar@1.16.1, unic-char-property@0.9.0, unic-char-range@0.9.0, unic-common@0.9.0, unic-emoji-char@0.9.0, unic-langid-impl@0.9.1, unic-langid-macros-impl@0.9.1, unic-langid-macros@0.9.1, unic-langid@0.9.1, unic-ucd-version@0.9.0, unicase@2.6.0, unicode-bidi@0.3.8, unicode-ident@1.0.5, unicode-normalization@0.1.22, unicode-script@0.5.5, unicode-security@0.1.0, unicode-segmentation@1.10.0, unicode-width@0.1.10, unicode-xid@0.2.4, unicode_categories@0.1.1, unified-diff@0.2.1, url@2.3.1, utf-8@0.7.5, uuid@0.8.2, valuable@0.1.0, version_check@0.9.4, walkdir@2.3.2, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.9.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.5, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.42.0, windows_aarch64_gnullvm@0.42.0, windows_aarch64_msvc@0.42.0, windows_i686_gnu@0.42.0, windows_i686_msvc@0.42.0, windows_x86_64_gnu@0.42.0, windows_x86_64_gnullvm@0.42.0, windows_x86_64_msvc@0.42.0, write-json@0.1.2, writeable@0.5.0, xattr@0.2.3, xflags-macros@0.3.0, xflags@0.3.0, xshell-macros@0.2.2, xshell@0.2.2, xz2@0.1.6, yansi-term@0.1.2, yansi@0.5.1, yoke-derive@0.6.1, yoke@0.6.2, zerofrom-derive@0.1.1, zerofrom@0.1.1, zerovec-derive@0.9.0, zerovec@0.9.0

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Suggests:
# lld and clang are needed for wasm compilation
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 cargo (>= 0.65.0~~), cargo (<< 0.66.0~~),
 llvm-15, lld-15, clang-15,
Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.67
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.67 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 15
OLD_LLVM_VERSION = 14
# used by the patched profiler build script
CLANG_RT_ARCH := $(DEB_TARGET_GNU_CPU)
ifeq (i386,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = i386
endif
ifeq (armhf,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = armhf
endif
export DEB_LLVM_VERSION = $(LLVM_VERSION)
export DEB_CLANG_RT_ARCH = $(CLANG_RT_ARCH)
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DVERBOSITY="$(VERBOSITY)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
# i386 and x32 fail to mmap rustc_driver when building rustdoc in >1.60
